Subject: Re: [PATCH 4.1 11/56] mvneta: add forgotten initialization of autonegotiation bits

From: Greg Kroah-Hartman <[email-masked]>
Date: Wed, 8 Jul 2015 10:36:55 -0700

On Wed, Jul 08, 2015 at 08:10:46PM +0300, Stas Sergeev wrote:
> 08.07.2015 10:35, Greg Kroah-Hartman пишет:
> >4.1-stable review patch.  If anyone has any objections, please let me know.
> >
> >------------------
> >
> >From: Stas Sergeev <[email-masked]>
> >
> >[ Upstream commit 538761b794c1542f1c6e31eadd9d7aae118889f7 ]
> >
> >The commit 898b2970e2c9 ("mvneta: implement SGMII-based in-band link state
> >signaling")
> >changed mvneta_adjust_link() so that it does not clear the auto-negotiation
> >bits in MVNETA_GMAC_AUTONEG_CONFIG register. This was necessary for
> >auto-negotiation mode to work.
> >Unfortunately I haven't checked if these bits are ever initialized.
> >It appears they are not.
> >This patch adds the missing initialization of the auto-negotiation bits
> >in the MVNETA_GMAC_AUTONEG_CONFIG register.
> >It fixes the following regression:
> >https://www.mail-archive.com/[email-masked]/msg67928.html
> >
> >Since the patch was tested to fix a regression, it should be applied to
> >stable tree.
> >
> >Tested-by: Arnaud Ebalard <[email-masked]>
> >
> >CC: Thomas Petazzoni <[email-masked]>
> >CC: Florian Fainelli <[email-masked]>
> >CC: [email-masked]
> >CC: [email-masked]
> >CC: [email-masked]
> >
> >Signed-off-by: Stas Sergeev <[email-masked]>
> >Signed-off-by: David S. Miller <[email-masked]>
> >Signed-off-by: Greg Kroah-Hartman <[email-masked]>
> >---
> >  drivers/net/ethernet/marvell/mvneta.c |    6 ++++++
> >  1 file changed, 6 insertions(+)
> >
> >--- a/drivers/net/ethernet/marvell/mvneta.c
> >+++ b/drivers/net/ethernet/marvell/mvneta.c
> >@@ -1013,6 +1013,12 @@ static void mvneta_defaults_set(struct m
> >  		val = mvreg_read(pp, MVNETA_GMAC_CLOCK_DIVIDER);
> >  		val |= MVNETA_GMAC_1MS_CLOCK_ENABLE;
> >  		mvreg_write(pp, MVNETA_GMAC_CLOCK_DIVIDER, val);
> >+	} else {
> >+		val = mvreg_read(pp, MVNETA_GMAC_AUTONEG_CONFIG);
> >+		val &= ~(MVNETA_GMAC_INBAND_AN_ENABLE |
> >+		       MVNETA_GMAC_AN_SPEED_EN |
> >+		       MVNETA_GMAC_AN_DUPLEX_EN);
> >+		mvreg_write(pp, MVNETA_GMAC_AUTONEG_CONFIG, val);
> >  	}
> >  	mvneta_set_ucast_table(pp, -1);
> Hi Greg.
> 
> Another problem was reported:
> https://lkml.org/lkml/2015/7/8/865
> 
> So, while the above patch is correct and fixes what
> it should, the original patch has more problems to deal
> with. Maybe for stable it would be better to just revert
> the whole thing?

No, you will have to fix this in Linus's tree, right?  So I'll take the
patch that you get into there when that happens, I don't want to diverge
from what is in that tree.

> I guess for stable I'll be posting the reverts instead of
> the above fix.

If you are reverting patches in Linus's tree, I'll take that as well.

thanks,

greg k-h